<?php

namespace EventPortal\Http\Middleware;

use Closure;
use EventPortal\Domain\Event\Models\EventDelegate;
use Illuminate\Http\Request;
use Illuminate\Http\Response;

class RequiresInvite
{
    /**
     * Handle an incoming request.
     *
     * @return mixed
     */
    public function handle(Request $request, Closure $next)
    {
        $user = auth()->user();

        if ($user->admin || EventDelegate::forEventAndDelegate($request->event, $user->delegate)->count()) {
            return $next($request);
        }

        abort(Response::HTTP_UNAUTHORIZED);
    }
}
