<?php

namespace EventPortal\Tests\Feature\Delegate;

use EventPortal\Domain\Delegate\Models\Delegate;
use EventPortal\Tests\TestCase;
use Illuminate\Foundation\Testing\RefreshDatabase;
use Spatie\Snapshots\MatchesSnapshots;

class AccountIndexTest extends TestCase
{
    use RefreshDatabase, MatchesSnapshots;

    /** @test */
    public function can_view_my_details()
    {
        $delegate = factory(Delegate::class)->state('snapshot')->create();

        $this->assertMatchesJsonSnapshot(
            $this->actingAs($delegate->user)
                ->get(route('account.my-details.index'))
                ->props()
        );
    }
}
