<?php

namespace EventPortal\Tests\Support\Factories;

use Carbon\Carbon;
use EventPortal\Domain\Agenda\Models\Agenda;
use EventPortal\Domain\Agenda\Models\Pathway;
use EventPortal\Domain\Event\Models\Event;

class AgendaFactory
{
    /**
     * @var Event
     */
    public $event;

    public function __construct(Carbon $date, Event $event)
    {
        $this->agenda = $this->create($date, $event);
    }

    public static function make(Carbon $date, Event $event): self
    {
        return new self($date, $event);
    }

    public function createPathway(string $name, callable $callable): self
    {
        $pathway = Pathway::create([
            'name' => $name,
            'agenda_id' => $this->agenda->id,
        ]);

        $this->pathway = $pathway->fresh();

        $callable(new PathwayFactory($pathway));

        return $this;
    }

    private function create(Carbon $date, Event $event): Agenda
    {
        return Agenda::create([
            'date' => $date,
            'event_id' => $event->id,
        ]);
    }
}
