<?php

namespace EventPortal\Tests\Support\Factories;

use EventPortal\Domain\Agenda\Models\Pathway;
use EventPortal\Domain\Agenda\Models\Session;
use EventPortal\Domain\Delegate\Models\Delegate;
use EventPortal\Domain\Event\Models\EventDelegate;

class PathwayFactory
{
    /**
     * @var Pathway
     */
    private $pathway;

    public function __construct(Pathway $pathway)
    {
        $this->pathway = $pathway;
    }

    public function addDelegate(Delegate $delegate): self
    {
        $this->pathway->agenda->event->delegates()->save($delegate, [
            'status' => 'invited',
        ]);

        $eventDelegates = EventDelegate::where('delegate_id', $delegate->id)
            ->where('event_id', $this->pathway->agenda->event->id)
            ->first();

        $this->pathway->eventDelegates()->save($eventDelegates);

        return $this;
    }

    public function createSession(array $data, callable $callback): Session
    {
        $session = factory(Session::class)->create($data);
        $this->pathway->sessions()->save($session);

        $callback(new SessionFactory($session));

        return $session;
    }
}
